Index: kernel/arch/amd64/include/arch/mm/pat.h
===================================================================
--- kernel/arch/amd64/include/arch/mm/pat.h	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ kernel/arch/amd64/include/arch/mm/pat.h	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2024 Jiří Zárevúcky
  * All rights reserved.
@@ -50,4 +51,5 @@
 } pat_type_t;
 
+#ifndef PROCESSOR_i486
 /**
  * Assign caching type for a particular combination of PAT,
@@ -65,4 +67,5 @@
 	write_msr(MSR_IA32_PAT, r);
 }
+#endif
 
 static inline bool pat_supported(void)
Index: kernel/arch/ia32/src/ia32.c
===================================================================
--- kernel/arch/ia32/src/ia32.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ kernel/arch/ia32/src/ia32.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2001-2004 Jakub Jermar
- * Copyright (c) 2009 Jiri Svoboda
  * Copyright (c) 2009 Martin Decky
  * All rights reserved.
@@ -106,7 +106,9 @@
 	pm_init();
 
+#ifndef PROCESSOR_i486
 	/* Use PCD+PWT bit combination in PTE to mean write-combining mode. */
 	if (pat_supported())
 		pat_set_mapping(false, true, true, PAT_TYPE_WRITE_COMBINING);
+#endif
 
 	if (config.cpu_active == 1) {
Index: kernel/generic/include/debug.h
===================================================================
--- kernel/generic/include/debug.h	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ kernel/generic/include/debug.h	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -38,4 +38,5 @@
 #include <log.h>
 #include <printf/verify.h>
+#include <symtab.h>
 
 #define CALLER  ((uintptr_t) __builtin_return_address(0))
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ kernel/generic/src/main/kinit.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -296,8 +296,5 @@
 			}
 
-		} else if (i == init.cnt - 1) {
-			/*
-			 * Assume the last task is the RAM disk.
-			 */
+		} else if (str_cmp(name, "initrd.img") == 0) {
 			init_rd((void *) init.tasks[i].paddr, init.tasks[i].size);
 		} else {
Index: meson/arch/amd64/meson.build
===================================================================
--- meson/arch/amd64/meson.build	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ meson/arch/amd64/meson.build	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -62,5 +62,5 @@
 	'drv/intctl/i8259',
 	'drv/platform/pc',
-	'drv/block/ata_bd',
+	'drv/block/isa-ide',
 	'drv/bus/pci/pciintel',
 	'drv/bus/isa',
@@ -76,5 +76,6 @@
 	'drv/audio/sb16',
 	'drv/block/ahci',
-	'drv/block/ata_bd',
+	'drv/block/isa-ide',
+	'drv/block/pci-ide',
 	'drv/block/usbmast',
 	'drv/block/virtio-blk',
Index: meson/arch/ia32/meson.build
===================================================================
--- meson/arch/ia32/meson.build	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ meson/arch/ia32/meson.build	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -68,5 +68,5 @@
 	'drv/intctl/i8259',
 	'drv/platform/pc',
-	'drv/block/ata_bd',
+	'drv/block/isa-ide',
 	'drv/bus/pci/pciintel',
 	'drv/bus/isa',
@@ -82,5 +82,6 @@
 	'drv/audio/sb16',
 	'drv/block/ahci',
-	'drv/block/ata_bd',
+	'drv/block/isa-ide',
+	'drv/block/pci-ide',
 	'drv/block/usbmast',
 	'drv/block/virtio-blk',
Index: meson/arch/mips32/meson.build
===================================================================
--- meson/arch/mips32/meson.build	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ meson/arch/mips32/meson.build	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -67,5 +67,5 @@
 		'drv/platform/malta',
 		'drv/intctl/i8259',
-		'drv/block/ata_bd',
+		'drv/block/isa-ide',
 		'drv/bus/pci/pciintel',
 		'drv/bus/isa',
Index: uspace/app/blkdump/blkdump.c
===================================================================
--- uspace/app/blkdump/blkdump.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/blkdump/blkdump.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Sucha
- * Copyright (c) 2013 Jiri Svoboda
  * All rights reserved.
  *
@@ -150,5 +150,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK)  {
 		printf(NAME ": Error initializing libblock.\n");
Index: uspace/app/dltest/dltest.c
===================================================================
--- uspace/app/dltest/dltest.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/dltest/dltest.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2016 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -571,4 +571,29 @@
 #ifdef DLTEST_LINKED
 
+/** Test if we can read the correct value of a public pointer variable.
+ *
+ * dl_public_ptr_var is initialized in libdltest to point to dl_public_var.
+ * This is done using a relocation. The main program (unless compiled with
+ * PIC or PIE) will contain a copy of dl_public_ptr_var. This needs
+ * to be copied using a COPY relocation. The relocations in the main
+ * program need to be processed after the relocations in the shared
+ * libraries (so that we copy the correct value).
+ */
+static bool test_public_ptr_var(void)
+{
+	int *ptr;
+
+	printf("Read dl_public_ptr_var directly...\n");
+	ptr = dl_public_ptr_var;
+
+	if (ptr != &dl_public_var) {
+		printf("FAILED\n");
+		return false;
+	}
+
+	printf("Passed\n");
+	return true;
+}
+
 /** Test directly calling function that returns a constant */
 static bool test_lnk_dl_get_constant(void)
@@ -920,4 +945,5 @@
 
 #ifndef STATIC_EXE
+
 	if (!test_dlfcn_dl_get_private_fib_var())
 		return 1;
@@ -974,4 +1000,7 @@
 
 	if (!test_lnk_read_public_uvar())
+		return 1;
+
+	if (!test_public_ptr_var())
 		return 1;
 
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/edit/edit.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2012 Martin Sucha
  * All rights reserved.
@@ -238,9 +238,21 @@
 
 static void edit_wnd_close(ui_window_t *, void *);
+static void edit_wnd_focus(ui_window_t *, void *, unsigned);
 static void edit_wnd_kbd_event(ui_window_t *, void *, kbd_event_t *);
+static void edit_wnd_unfocus(ui_window_t *, void *, unsigned);
 
 static ui_window_cb_t edit_window_cb = {
 	.close = edit_wnd_close,
-	.kbd = edit_wnd_kbd_event
+	.focus = edit_wnd_focus,
+	.kbd = edit_wnd_kbd_event,
+	.unfocus = edit_wnd_unfocus
+};
+
+static void edit_menubar_activate(ui_menu_bar_t *, void *);
+static void edit_menubar_deactivate(ui_menu_bar_t *, void *);
+
+static ui_menu_bar_cb_t edit_menubar_cb = {
+	.activate = edit_menubar_activate,
+	.deactivate = edit_menubar_deactivate
 };
 
@@ -431,4 +443,6 @@
 	}
 
+	ui_menu_bar_set_cb(edit->menubar, &edit_menubar_cb, (void *) edit);
+
 	rc = ui_menu_dd_create(edit->menubar, "~F~ile", NULL, &mfile);
 	if (rc != EOK) {
@@ -2221,4 +2235,19 @@
 }
 
+/** Window focus event
+ *
+ * @param window Window
+ * @param arg Argument (edit_t *)
+ * @param focus Focus number
+ */
+static void edit_wnd_focus(ui_window_t *window, void *arg, unsigned focus)
+{
+	edit_t *edit = (edit_t *)arg;
+
+	(void)edit;
+	pane_caret_display(&pane);
+	cursor_setvis(true);
+}
+
 /** Window keyboard event
  *
@@ -2242,4 +2271,45 @@
 }
 
+/** Window unfocus event
+ *
+ * @param window Window
+ * @param arg Argument (edit_t *)
+ * @param focus Focus number
+ */
+static void edit_wnd_unfocus(ui_window_t *window, void *arg, unsigned focus)
+{
+	edit_t *edit = (edit_t *) arg;
+
+	(void)edit;
+	cursor_setvis(false);
+}
+
+/** Menu bar activate event
+ *
+ * @param mbar Menu bar
+ * @param arg Argument (edit_t *)
+ */
+static void edit_menubar_activate(ui_menu_bar_t *mbar, void *arg)
+{
+	edit_t *edit = (edit_t *)arg;
+
+	(void)edit;
+	cursor_setvis(false);
+}
+
+/** Menu bar deactivate event
+ *
+ * @param mbar Menu bar
+ * @param arg Argument (edit_t *)
+ */
+static void edit_menubar_deactivate(ui_menu_bar_t *mbar, void *arg)
+{
+	edit_t *edit = (edit_t *)arg;
+
+	(void)edit;
+	pane_caret_display(&pane);
+	cursor_setvis(true);
+}
+
 /** File / Save menu entry selected.
  *
@@ -2407,13 +2477,9 @@
 {
 	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
 	char *cname;
 	errno_t rc;
 
+	(void)edit;
 	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 
 	cname = str_dup(fname);
@@ -2441,11 +2507,7 @@
 {
 	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2458,11 +2520,7 @@
 {
 	edit_t *edit = (edit_t *)arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_file_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2477,5 +2535,4 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
 	char *endptr;
 	int line;
@@ -2489,8 +2546,6 @@
 
 	caret_move_absolute(line, pane.ideal_column, dir_before, false);
-	// TODO Smarter cursor management
+	(void)edit;
 	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-	(void) gfx_update(gc);
 }
 
@@ -2503,11 +2558,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2520,11 +2571,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2539,8 +2586,8 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
 	char *pattern;
 	bool reverse;
 
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
 
@@ -2559,8 +2606,5 @@
 	search(pattern, reverse);
 
-	// TODO Smarter cursor management
 	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
-	(void) gfx_update(gc);
 }
 
@@ -2573,11 +2617,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
@@ -2590,11 +2630,7 @@
 {
 	edit_t *edit = (edit_t *) arg;
-	gfx_context_t *gc = ui_window_get_gc(edit->window);
-
+
+	(void)edit;
 	ui_prompt_dialog_destroy(dialog);
-	// TODO Smarter cursor management
-	pane.rflags |= REDRAW_CARET;
-	(void) pane_update(&pane);
-	gfx_cursor_set_visible(gc, true);
 }
 
Index: uspace/app/hbench/benchlist.c
===================================================================
--- uspace/app/hbench/benchlist.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/hbench/benchlist.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2018 Vojtech Horky
  * All rights reserved.
@@ -42,4 +42,6 @@
 	&benchmark_fibril_mutex,
 	&benchmark_file_read,
+	&benchmark_rand_read,
+	&benchmark_seq_read,
 	&benchmark_malloc1,
 	&benchmark_malloc2,
Index: uspace/app/hbench/disk/randread.c
===================================================================
--- uspace/app/hbench/disk/randread.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
+++ uspace/app/hbench/disk/randread.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -0,0 +1,146 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup hbench
+ * @{
+ */
+
+#include <block.h>
+#include <loc.h>
+#include <str_error.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "../hbench.h"
+
+/** Execute disk random read benchmark. */
+static bool runner(bench_env_t *env, bench_run_t *run, uint64_t size)
+{
+	const char *disk;
+	const char *nbstr;
+	service_id_t svcid;
+	size_t block_size;
+	aoff64_t dev_nblocks;
+	aoff64_t baddr;
+	bool block_inited = false;
+	char *buf = NULL;
+	uint64_t i;
+	errno_t rc;
+	int nitem;
+	unsigned nb;
+
+	disk = bench_env_param_get(env, "disk", NULL);
+	if (disk == NULL) {
+		bench_run_fail(run, "You must specify 'disk' parameter.");
+		goto error;
+	}
+
+	nbstr = bench_env_param_get(env, "nb", "1");
+	nitem = sscanf(nbstr, "%u", &nb);
+	if (nitem < 1) {
+		bench_run_fail(run, "'nb' must be an integer number of blocks.");
+		goto error;
+	}
+
+	rc = loc_service_get_id(disk, &svcid, 0);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed resolving device '%s'", disk);
+		goto error;
+	}
+
+	rc = block_init(svcid);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed opening block device '%s'",
+		    disk);
+	}
+
+	block_inited = true;
+
+	rc = block_get_bsize(svcid, &block_size);
+	if (rc != EOK) {
+		bench_run_fail(run, "error determining device block size.");
+		goto error;
+	}
+
+	rc = block_get_nblocks(svcid, &dev_nblocks);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed to obtain block device size.\n");
+		goto error;
+	}
+
+	if (dev_nblocks < nb) {
+		bench_run_fail(run, "device is smaller than %u blocks.\n",
+		    nb);
+		goto error;
+	}
+
+	buf = malloc(block_size * nb);
+	if (buf == NULL) {
+		bench_run_fail(run, "failed to allocate buffer (%zu bytes)",
+		    block_size * nb);
+		goto error;
+	}
+
+	bench_run_start(run);
+	for (i = 0; i < size; i++) {
+		/* Generate pseudo-random block address */
+		baddr = (rand() + rand() * RAND_MAX) % (dev_nblocks - nb + 1);
+
+		rc = block_read_direct(svcid, baddr, nb, buf);
+		if (rc != EOK) {
+			bench_run_fail(run, "failed to read blockd %llu-%llu: "
+			    "%s", (unsigned long long)baddr,
+			    (unsigned long long)(baddr + nb - 1),
+			    str_error(errno));
+			goto error;
+		}
+	}
+
+	bench_run_stop(run);
+	block_fini(svcid);
+	free(buf);
+
+	return true;
+error:
+	if (buf != NULL)
+		free(buf);
+	if (block_inited)
+		block_fini(svcid);
+	return false;
+}
+
+benchmark_t benchmark_rand_read = {
+	.name = "rand_read",
+	.desc = "Random disk read (must set 'disk' parameter).",
+	.entry = &runner,
+	.setup = NULL,
+	.teardown = NULL
+};
+
+/**
+ * @}
+ */
Index: uspace/app/hbench/disk/seqread.c
===================================================================
--- uspace/app/hbench/disk/seqread.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
+++ uspace/app/hbench/disk/seqread.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -0,0 +1,145 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup hbench
+ * @{
+ */
+
+#include <block.h>
+#include <loc.h>
+#include <str_error.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include "../hbench.h"
+
+/** Execute disk sequential read benchmark. */
+static bool runner(bench_env_t *env, bench_run_t *run, uint64_t size)
+{
+	const char *disk;
+	const char *nbstr;
+	service_id_t svcid;
+	size_t block_size;
+	aoff64_t dev_nblocks;
+	aoff64_t baddr;
+	bool block_inited = false;
+	char *buf = NULL;
+	uint64_t i;
+	errno_t rc;
+	int nitem;
+	unsigned nb;
+
+	disk = bench_env_param_get(env, "disk", NULL);
+	if (disk == NULL) {
+		bench_run_fail(run, "Yo must specify 'disk' parameter.");
+		goto error;
+	}
+
+	nbstr = bench_env_param_get(env, "nb", "1");
+	nitem = sscanf(nbstr, "%u", &nb);
+	if (nitem < 1) {
+		bench_run_fail(run, "'nb' must be an integer number of blocks.");
+		goto error;
+	}
+
+	rc = loc_service_get_id(disk, &svcid, 0);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed resolving device '%s'", disk);
+		goto error;
+	}
+
+	rc = block_init(svcid);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed opening block device '%s'",
+		    disk);
+	}
+
+	block_inited = true;
+
+	rc = block_get_bsize(svcid, &block_size);
+	if (rc != EOK) {
+		bench_run_fail(run, "error determining device block size.");
+		goto error;
+	}
+
+	rc = block_get_nblocks(svcid, &dev_nblocks);
+	if (rc != EOK) {
+		bench_run_fail(run, "failed to obtain block device size.\n");
+		goto error;
+	}
+
+	if (dev_nblocks < nb) {
+		bench_run_fail(run, "device is smaller than %u blocks.\n",
+		    nb);
+		goto error;
+	}
+
+	buf = malloc(block_size);
+	if (buf == NULL) {
+		bench_run_fail(run, "failed to allocate buffer (%zu bytes)",
+		    block_size);
+		goto error;
+	}
+
+	bench_run_start(run);
+	for (i = 0; i < size; i++) {
+		baddr = i % (dev_nblocks - nb + 1);
+
+		rc = block_read_direct(svcid, baddr, 1, buf);
+		if (rc != EOK) {
+			bench_run_fail(run, "failed to read blocks %llu-%llu: "
+			    "%s", (unsigned long long)baddr,
+			    (unsigned long long)(baddr + nb - 1),
+			    str_error(errno));
+			goto error;
+		}
+	}
+
+	bench_run_stop(run);
+	block_fini(svcid);
+	free(buf);
+
+	return true;
+error:
+	if (buf != NULL)
+		free(buf);
+	if (block_inited)
+		block_fini(svcid);
+	return false;
+}
+
+benchmark_t benchmark_seq_read = {
+	.name = "seq_read",
+	.desc = "Sequential disk read (must set 'disk' parameter).",
+	.entry = &runner,
+	.setup = NULL,
+	.teardown = NULL
+};
+
+/**
+ * @}
+ */
Index: uspace/app/hbench/hbench.h
===================================================================
--- uspace/app/hbench/hbench.h	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/hbench/hbench.h	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2023 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2019 Vojtech Horky
  * All rights reserved.
@@ -135,4 +135,6 @@
 extern benchmark_t benchmark_fibril_mutex;
 extern benchmark_t benchmark_file_read;
+extern benchmark_t benchmark_rand_read;
+extern benchmark_t benchmark_seq_read;
 extern benchmark_t benchmark_malloc1;
 extern benchmark_t benchmark_malloc2;
Index: uspace/app/hbench/meson.build
===================================================================
--- uspace/app/hbench/meson.build	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/hbench/meson.build	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2023 Jiri Svoboda
+# Copyright (c) 2024 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,5 +27,5 @@
 #
 
-deps = [ 'math', 'ipctest' ]
+deps = [ 'block', 'math', 'ipctest' ]
 src = files(
 	'benchlist.c',
@@ -34,4 +34,6 @@
 	'main.c',
 	'utils.c',
+	'disk/randread.c',
+	'disk/seqread.c',
 	'fs/dirread.c',
 	'fs/fileread.c',
Index: uspace/app/init/untar.c
===================================================================
--- uspace/app/init/untar.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/init/untar.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2018 Martin Decky
  * All rights reserved.
@@ -59,5 +60,5 @@
 		return ret;
 
-	ret = block_init(state->sid, 4096);
+	ret = block_init(state->sid);
 	if (ret != EOK)
 		return ret;
Index: uspace/app/mkexfat/mkexfat.c
===================================================================
--- uspace/app/mkexfat/mkexfat.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/mkexfat/mkexfat.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2012 Maurizio Lombardi
  * All rights reserved.
@@ -858,5 +859,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK) {
 		printf(NAME ": Error initializing libblock.\n");
Index: uspace/app/mkfat/mkfat.c
===================================================================
--- uspace/app/mkfat/mkfat.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/mkfat/mkfat.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,5 +66,6 @@
 	default_fat_count		= 2,
 	default_reserved_clusters	= 2,
-	default_media_descriptor	= 0xF8 /**< fixed disk */
+	default_media_descriptor	= 0xF8 /**< fixed disk */,
+	fat32_root_cluster		= 2
 };
 
@@ -198,5 +199,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK)  {
 		printf(NAME ": Error initializing libblock.\n");
@@ -313,5 +314,5 @@
 	cfg->reserved_sectors = 1 + cfg->addt_res_sectors;
 
-	/* Only correct for FAT12/16 (FAT32 has root dir stored in clusters */
+	/* Only correct for FAT12/16 (FAT32 has root dir stored in clusters) */
 	rd_sectors = div_round_up(cfg->root_ent_max * DIRENT_SIZE,
 	    cfg->sector_size);
@@ -434,4 +435,9 @@
 	}
 
+	if (cfg->fat_type == FAT32) {
+		/* Root dir is stored in cluster fat32_root_cluster */
+		addr += fat32_root_cluster * cfg->sectors_per_cluster;
+	}
+
 	/* Root directory */
 	printf("Writing root directory.\n");
@@ -529,5 +535,5 @@
 		bs->fat32.ebs = 0x29;
 		bs->fat32.id = host2uint32_t_be(vsn);
-		bs->fat32.root_cluster = 2;
+		bs->fat32.root_cluster = fat32_root_cluster;
 
 		(void) fat_label_encode(&bs->fat32.label, bs_label);
Index: uspace/app/mkmfs/mkmfs.c
===================================================================
--- uspace/app/mkmfs/mkmfs.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/mkmfs/mkmfs.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Maurizio Lombardi
  * All rights reserved.
@@ -211,5 +212,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK)  {
 		printf(NAME ": Error initializing libblock.\n");
Index: uspace/app/sysinst/sysinst.c
===================================================================
--- uspace/app/sysinst/sysinst.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/app/sysinst/sysinst.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2018 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,5 +62,6 @@
  * in Grub notation).
  */
-#define DEFAULT_DEV "devices/\\hw\\sys\\00:01.0\\ata-c1\\d0"
+#define DEFAULT_DEV_0 "devices/\\hw\\sys\\00:01.1\\c0d0"
+#define DEFAULT_DEV_1 "devices/\\hw\\sys\\00:01.0\\ata1\\c0d0"
 //#define DEFAULT_DEV "devices/\\hw\\pci0\\00:01.2\\uhci_rh\\usb01_a1\\mass-storage0\\l0"
 /** Volume label for the new file system */
@@ -79,8 +80,34 @@
 #define BOOT_BLOCK_IDX 0 /* MBR */
 
+static const char *default_devs[] = {
+	DEFAULT_DEV_0,
+	DEFAULT_DEV_1,
+	NULL
+};
+
 static const char *sys_dirs[] = {
 	"/cfg",
-	"/data"
+	"/data",
+	NULL
 };
+
+/** Check the if the destination device exists.
+ *
+ * @param dev Disk device
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t sysinst_check_dev(const char *dev)
+{
+	service_id_t sid;
+	errno_t rc;
+
+	rc = loc_service_get_id(dev, &sid, 0);
+	if (rc != EOK)
+		return rc;
+
+	(void)sid;
+	return EOK;
+}
 
 /** Label the destination device.
@@ -361,5 +388,5 @@
 
 	printf("sysinst_copy_boot_blocks: block_init.\n");
-	rc = block_init(sid, 512);
+	rc = block_init(sid);
 	if (rc != EOK)
 		return rc;
@@ -490,6 +517,20 @@
 int main(int argc, char *argv[])
 {
-	const char *dev = DEFAULT_DEV;
-	return sysinst_install(dev);
+	unsigned i;
+	errno_t rc;
+
+	i = 0;
+	while (default_devs[i] != NULL) {
+		rc = sysinst_check_dev(default_devs[i]);
+		if (rc == EOK)
+			break;
+	}
+
+	if (default_devs[i] == NULL) {
+		printf("Cannot determine installation device.\n");
+		return 1;
+	}
+
+	return sysinst_install(default_devs[i]);
 }
 
Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -58,5 +58,5 @@
 static errno_t hda_fun_offline(ddf_fun_t *fun);
 
-static void hdaudio_interrupt(ipc_call_t *, ddf_dev_t *);
+static void hdaudio_interrupt(ipc_call_t *, void *);
 
 static driver_ops_t driver_ops = {
@@ -266,5 +266,5 @@
 	cap_irq_handle_t irq_cap;
 	rc = register_interrupt_handler(dev, res.irqs.irqs[0],
-	    hdaudio_interrupt, &irq_code, &irq_cap);
+	    hdaudio_interrupt, (void *)hda, &irq_code, &irq_cap);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler: %s",
@@ -377,7 +377,12 @@
 }
 
-static void hdaudio_interrupt(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	hda_t *hda = (hda_t *)ddf_dev_data_get(dev);
+/** HD Audio interrupt handler.
+ *
+ * @param icall IRQ event notification
+ * @param arg Argument (hda_t *)
+ */
+static void hdaudio_interrupt(ipc_call_t *icall, void *arg)
+{
+	hda_t *hda = (hda_t *)arg;
 
 	if (0)
Index: uspace/drv/audio/sb16/main.c
===================================================================
--- uspace/drv/audio/sb16/main.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/drv/audio/sb16/main.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -76,7 +76,12 @@
 }
 
-static void irq_handler(ipc_call_t *call, ddf_dev_t *dev)
-{
-	sb16_t *sb16_dev = ddf_dev_data_get(dev);
+/** SB16 IRQ handler.
+ *
+ * @param call IRQ event notification
+ * @param arg Argument (sb16_t *)
+ */
+static void irq_handler(ipc_call_t *call, void *arg)
+{
+	sb16_t *sb16_dev = (sb16_t *)arg;
 	sb16_interrupt(sb16_dev);
 }
@@ -124,5 +129,5 @@
 
 	rc = register_interrupt_handler(device, irq, irq_handler,
-	    &irq_code, &irq_cap);
+	    (void *)soft_state, &irq_code, &irq_cap);
 	if (rc != EOK) {
 		ddf_log_error("Failed to register irq handler: %s.",
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/drv/block/ahci/ahci.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -162,10 +162,4 @@
 }
 
-/** Get AHCI structure from DDF device. */
-static ahci_dev_t *dev_ahci_dev(ddf_dev_t *dev)
-{
-	return ddf_dev_data_get(dev);
-}
-
 /** Get SATA device name.
  *
@@ -891,10 +885,9 @@
  *
  * @param icall The IPC call structure.
- * @param dev   DDF device structure.
- *
- */
-static void ahci_interrupt(ipc_call_t *icall, ddf_dev_t *dev)
-{
-	ahci_dev_t *ahci = dev_ahci_dev(dev);
+ * @param arg   Argument (ahci_dev_t *)
+ */
+static void ahci_interrupt(ipc_call_t *icall, void *arg)
+{
+	ahci_dev_t *ahci = (ahci_dev_t *)arg;
 	unsigned int port = ipc_get_arg1(icall);
 	ahci_port_is_t pxis = ipc_get_arg2(icall);
@@ -1186,5 +1179,6 @@
 	cap_irq_handle_t irq_cap;
 	errno_t rc = register_interrupt_handler(dev,
-	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, &ct, &irq_cap);
+	    hw_res_parsed.irqs.irqs[0], ahci_interrupt, (void *)ahci, &ct,
+	    &irq_cap);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed registering interrupt handler.");
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision 2a0c827c42eafb070de3bbe3c98a1d8a2b77d719)
+++ uspace/drv/block/ddisk/ddisk.c	(revision 87488278a46c7a401ce6ee33baff59600dfccf37)
@@ -64,5 +64,5 @@
 static void ddisk_bd_connection(ipc_call_t *, void *);
 
-static void ddisk_irq_handler(ipc_call_t *, ddf_dev_t *);
+static void ddisk_irq_handler(ipc_call_t *, void *);
 
 static driver_ops_t driver_ops = {
@@ -176,10 +176,15 @@
 };
 
-void ddisk_irq_handler(ipc_call_t *icall, ddf_dev_t *dev)
+/** Ddisk IRQ handler.
+ *
+ * @param icall IRQ event notification
+ * @param arg Argument (ddisk_t *)
+ */
+void ddisk_irq_handler(ipc_call_t *icall, void *arg)
 {
 	ddf_msg(LVL_DEBUG, "ddisk_irq_handler(), status=%" PRIx32,
 	    (uint32_t) ipc_get_arg1(icall));
 
-	ddisk_t *ddisk = (ddisk_t *) ddf_dev_data_get(dev);
+	ddisk_t *ddisk = (ddisk_t *)arg;
 
 	fibril_mutex_lock(&ddisk->lock);
@@ -512,5 +517,5 @@
 	ddisk_irq_commands[3].addr = (void *) &res_phys->command;
 	rc = register_interrupt_handler(dev, ddisk->ddisk_res.irq,
-	    ddisk_irq_handler, &ddisk_irq_code, &ddisk->irq_cap);
+	    ddisk_irq_handler, (void *)ddisk, &ddisk_irq_code, &ddisk->irq_cap);
 	if (rc != EOK) {
 		ddf_msg(LVL_ERROR, "Failed to register interrupt handler.");
